# -*- coding: iso-8859-1 -*-
hinweis="""
# Aus dem Vorschlag
# GK Aufgabenbeispiel 1 - [154 kB] - 6.07.2005
# inf-gk-aufgabe-1.pdf
# nach Python bertragen
#
# Quelle der Aufgabenstellung:
#
# http://www.learn-line.nrw.de/angebote/abitur/download/inf-gk-aufgabe-1.pdf
# http://www.learn-line.nrw.de/angebote/abitur/fach.php?fach=15
#
# StD Dipl.-Inform. Dr. rer. nat. L. Humbert
#   http://humbert.in.hagen.de/iffase/ -- Zeitschrift zur Informatiklehrerbildung
#   http://humbert.in.hagen.de/ddi/    -- Didaktik der Informatik
# 20., 19., 18. August 2005
"""

from Queue import Queue 
       
class Handkartenpaeckchen :
    
    def __init__(self) :
        self.anzahl = 0 # int
        self.karten= Queue() # hat Queue

    def obersteKarte (self) :
        return self.karten.dequeue() # Spielkarte
        self.anzahl= self.anzahl-1

    def fuegeAn (self, pKarte) :
        self.karten.enqueue(pKarte)
        self.anzahl= self.anzahl+1

    def entferneObersteKarte (self) :
        dummy=self.obersteKarte()        

    def anzahl (self) :
        return self.anzahl# int

    def __print__ (self) :
        self.karten.__print__ ()

        
from Liste import List
from random import randint


class Spielkartenpaeckchen :    
    
    def __init__(self) :
        self.hatKarten= List() # n Karten werden zu Beginn erzeugt
        namen=["Sauber","Alfa","BMW","Audi","Mercedes","Honda","Ferrari","Toyota","Renault"]
        hubraeume=[500,1500,3000,6000,9000]
        leistungen=[100,110,350,420,500,719,720]
        geschwindigkeiten=[171,210,212,310,315]
        # erzeuge Kartenspiel
        # erzeuge 80 Karten
        for zahl in range(80):
            ## print zahl,
            par1=randint(0,len(namen)-1)
            par2=randint(0,len(hubraeume)-1)
            par3=randint(0,len(leistungen)-1)
            par4=randint(0,len(geschwindigkeiten)-1)
            karte=Spielkarte(
                    namen[par1],
                    hubraeume[par2],
                    leistungen[par3],
                    geschwindigkeiten[par4]
                            )                            
            # hnge erzeugte Karte an die Liste an
            self.hatKarten.insertBehind(karte)
            # Kontrollausgabe
            ## karte.__print__()
            
        self.anzahl= self.hatKarten.length()
        # Kontrollausgabe der Anzahl
        ## print "Es wurden",self.anzahl,"Karten erzeugt"
        print "Es wurden",self.erbitteAnzahl(),"Karten erzeugt"

        
    def __print__(self):
        print "==>",self.hatKarten.__print__()
        
    def obersteKarte (self) :             # top
        return self.hatKarten.getObject() # Spielkarte

    def zufallszahl (self, maximum):    
        return randint(1,maximum)
        
    def mische (self) :
        # lVorneAnfuegen: boolean;
        # lKarte: tObject;
        # lZaehler1, lZaehler2, lZufallszahl: integer;
        lVorneAnfuegen= True

        for lZaehler1 in range(1, 2*self.anzahl +1 ):
          ## print lZaehler1,
          self.hatKarten.toFirst()
          lZufallszahl= self.zufallszahl(self.anzahl)-1

          for lZaehler2 in range(1,lZufallszahl):
            self.hatKarten.next()
          lKarte=self.hatKarten.getObject()
          self.hatKarten.delete()
          if lVorneAnfuegen: 
            self.hatKarten.toFirst()
            self.hatKarten.insertBefore(lKarte)
          else:
            self.hatKarten.toLast()
            self.hatKarten.insertBehind(lKarte)

          lVorneAnfuegen= not lVorneAnfuegen

        
    def gibBesteKarten(self):
        # lMaxHubraum, lMaxLeistung, lMaxGeschwindigkeit: integer;
        # lErgebnis: Handkartenpaeckchen;
        # lBesteKarten: Handkartenpaeckchen;
        # lKarte: Spielkarte;
        lMaxHubraum         = 0
        lMaxLeistung        = 0
        lMaxGeschwindigkeit = 0

        lBesteKarten= Handkartenpaeckchen()
        
        self.hatKarten.toFirst()        
        while not self.hatKarten.isBehind():
          #print "ok",
          lKarte= self.hatKarten.getObject()
          if lKarte.hubraum() > lMaxHubraum:
            lMaxHubraum= lKarte.hubraum()
          if lKarte.leistung() > lMaxLeistung:
            lMaxLeistung= lKarte.leistung()
          if lKarte.geschwindigkeit() > lMaxGeschwindigkeit:
            lMaxGeschwindigkeit= lKarte.geschwindigkeit()
          self.hatKarten.next()   

        self.hatKarten.toFirst()
        while not self.hatKarten.isBehind():  
          lKarte=self.hatKarten.getObject()
          if ( 
               lMaxHubraum == lKarte.hubraum()  or 
               lMaxLeistung == lKarte.leistung()  or
               lMaxGeschwindigkeit == lKarte.geschwindigkeit() 
             ):
             lBesteKarten.fuegeAn(lKarte)
             self.hatKarten.delete()
             self.anzahl= self.anzahl - 1
          else:
             self.hatKarten.next()   
        
        return  lBesteKarten    

    
    def anzahl (self) :
        return self.anzahl


    # Implementierung, 
    # wie in "inf-gk-aufgabe-3.pdf", Seite 4,5
    # vorgeschlagen
    # dies ist berflssig,
    # da die Methode (Anfrage) 
    # self.anzahl()
    # das gleiche Ergebnis liefert
    def erbitteAnzahl(self):
        #return self.anzahl()
        zaehler=0
        if not self.hatKarten.isEmpty():
            self.hatKarten.toFirst()
            while not self.hatKarten.isBehind():
                zaehler=zaehler+1
                self.hatKarten.next()
        return zaehler        
        



    def entferneObersteKarte (self) :
        self.hatKarten.toFirst()
        self.hatKarten.delete()


        

class Spielkarte :
    def __init__(self, pName, pHubraum, pLeistung, pGeschwindigkeit) :
        self.zName = pName # string
        self.zHubraum = pHubraum # int
        self.zLeistung = pLeistung # int
        self.zGeschwindigkeit =  pGeschwindigkeit # int

    def name (self) :
        return self.zName # string
        
    def hubraum (self) :
        return self.zHubraum # int
        
    def leistung (self) :
        return self.zLeistung # int
        
    def geschwindigkeit (self) :
        return self.zGeschwindigkeit # int

    def __print__ (self) :
        print self.name(), self.hubraum(), self.leistung(), self.geschwindigkeit(),



if __name__ == "__main__":
    debug= True
    debug= False
    
    print hinweis
    print "Zentralabitur Informatik - 2007 \n"
    print "Beispielaufgabe -- Autoquartett \n"
    print "bersetzt nach Python \n"
    print "Instanziierung eines ... 'Spielkartenpckchens'"
    print

    print "paeckchen= Spielkartenpaeckchen()"
    paeckchen= Spielkartenpaeckchen()
    
    if debug: paeckchen.__print__()
    
    print "paeckchen.mische()"
    paeckchen.mische()

    if debug: print "paeckchen.__print__()"; paeckchen.__print__()
        
    print "besteKarten= paeckchen.gibBesteKarten()"
    besteKarten= paeckchen.gibBesteKarten()
    
    print "besteKarten.__print__()"
    besteKarten.__print__()


