# -*- coding: iso-8859-1 -*-
hinweis="""
# Nach dem Vorschlag
# GK Aufgabenbeispiel 1 - [154 kB] - 6.07.2005
# inf-gk-aufgabe-1.pdf
# nach Python bertragen
#
# StD Dipl.-Inform. Dr. rer. nat. L. Humbert
# 20., 19., 18. August 2005
"""
class List :
    def __init__(self) :
        self.liste=[]
        self.aktuellePosition=-1

    def length (self):
        return len(self.liste)
        
    def isEmpty (self):
        return self.length()==0

    def isBefore (self):
        return self.aktuellePosition==-1

    def isBehind (self) :
        return self.aktuellePosition == self.length()

    def next (self) :
        if self.isBehind(): return
        self.aktuellePosition=self.aktuellePosition+1
    
    def previous (self):
        if self.isBefore(): return
        self.aktuellePosition=self.aktuellePosition-1
        
    def toFirst (self):
        self.aktuellePosition=0

    def toLast (self):
        if self.length()==0: 
            self.aktuellePosition=-1
        else:    
            self.aktuellePosition=self.length()-1

    def getObject (self) :
        if self.isBefore() or self.isBehind() : return None
        return self.liste[self.aktuellePosition]       

    def update (self, element):
        if self.isBefore() or self.isBehind() or self.isEmpty():
            raise("Vorbedinung fr List.update() nicht erfllt")
        self.liste[self.aktuellePosition]= element    

    def insertBefore (self, element) :
        if self.isBefore():  
            raise("Vorbedinung fr List.insertBefore() nicht erfllt")        
        self.liste.insert(self.aktuellePosition, element)
        self.next()

    def insertBehind (self, element) :
        if self.isBehind():
            raise("Vorbedinung fr List.insertBehind() nicht erfllt")        
        self.liste.insert(self.aktuellePosition+1, element)

    def delete (self) :
        if self.length()==0: return
        del self.liste[self.aktuellePosition]

    def __print__ (self) :   
        zaehler=0
        print "[",
        for element in self.liste:            
            zaehler=zaehler+1
            if element != None:
                print zaehler,            
                try: element.__print__()
                except: print element,
                if self.length()>zaehler: print ",",
        print "]", zaehler,"Element(e) in der Liste"

if __name__ == "__main__":
    print hinweis
    print "Test der Klasse List"
    print "===================="
    print "Instanziierung:"
    print "listtest=List()"
    listtest=List()
    print "==>",listtest.liste
    print "==>", listtest.__print__ ()
    print
    
    print "listtest.toFirst()"
    listtest.toFirst()
    print 'listtest.insertBefore("1. Element")'
    listtest.insertBefore("1. Element")
    print "==>",listtest.liste 
    print "==>",listtest.__print__ ()
    print
    
    
    print "listtest.toFirst()"
    listtest.toFirst()
    print 'listtest.insertBehind("2. Element")'
    listtest.insertBehind("2. Element")
    print "==>",listtest.liste
    print "==>",listtest.__print__ ()
    print
    
    print "listtest.toLast()"
    listtest.toLast()
    print 'listtest.insertBefore("3. Element")'
    listtest.insertBefore("3. Element")
    print "==>",listtest.liste    
    print
    
    print "listtest.toFirst()"
    listtest.toFirst()
    print 'listtest.insertBehind("4. Element")'
    listtest.insertBehind("4. Element")
    print "==>",listtest.liste
    print "==>",listtest.__print__ ()
    print
       
    print "listtest.getObject()"
    print listtest.getObject()
    
    print "listtest.toLast()"
    listtest.toLast()
    print "listtest.getObject()"
    print listtest.getObject()
    
    print 'listtest.delete()'
    listtest.delete()
    listtest.previous()
    print "==>",listtest.liste
    print

    print 'listtest.delete()'
    listtest.delete()
    listtest.previous()
    print "==>",listtest.liste
    print
    
    print 'listtest.delete()'
    listtest.delete()
    listtest.previous()
    print "==>",listtest.liste
    print

    print 'listtest.delete()'
    listtest.delete()
    listtest.previous()
    print "==>",listtest.liste
    print

    print 'listtest.delete()'
    listtest.previous()
    listtest.delete()
    print "==>",listtest.liste

"""
Element[e] lschen

    del L[i] # lscht das Element mit dem Index i
    del L[i:j] # lscht die Elemente i..j
    
    L.remove(x) entfernt das Element x aus der Liste
    kann auch mit del L[L.index(x)] erledigt werden
    
    L.pop() # liefert das letzte Element der Liste und lscht es
    L.pop(i) # liefert das ite Element der Liste und lscht es

    
Elemente hinzufgen

    L.append(x) ## fgt das Element x am Ende der Liste an
                ## L[len(L):]=x
    L.extend(X) ## fgt die Liste X am Ende der Liste ein
                ## L[len(L):]=X
                
    L.insert(i,x) ## fgt das Element x an der Stelle i ein 
    
    
Elemente finden

    L.index(x) ## liefert den Index des ersten Auftretens von x    
               ## Fehlermeldung ValueError, wenn das Element nicht existiert 
    L.count(x) ## gibt die Anzahl von Element x in der Liste zurck 
    
    x in L ## liefert den Wahrheitswert True, wenn x in der Liste vorhanden ist
           ## sonst False


Liste umsortieren

    L.reverse() ## dreht die Reihenfolge der Liste um
                ## verndert die Liste
                
    L.sort() ## sortierte die Elemente der Liste aufsteigend  
    L.sort(smpfn) ## sortiert die Elemente gem der Funktion smpfn
                  
Thomas W. Christopher: Python Programming Patterns
Upper Saddle River, NJ : Prentice Hall
2002
ISBN 0-13-040956-1

8.3 Lists
S. 186ff
"""
  
